/*
 * $Id: liblzostream_utils.cpp,v 1.1 2014-02-10 10:28:29 swaj Exp $
 * Was written by Alexey Semenoff (c) 2012-2014
 * See COPYING for copyiright policy
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <lzo/lzo1x.h>
#include "liblzostream_utils.h"

//------------------------------------------------------------------------------
/* static */
const SDataCompressorUtils::ErrMap SDataCompressorUtils::SLzoErrors[] = {
    { LZO_E_ERROR,               EError            },
    { LZO_E_OUT_OF_MEMORY,       EMemError         },
    { LZO_E_NOT_COMPRESSIBLE,    ENotCompressible  },
    { LZO_E_INPUT_OVERRUN,       EInputOverrun     },
    { LZO_E_OUTPUT_OVERRUN,      EOutputOverrun    },
    { LZO_E_LOOKBEHIND_OVERRUN,  ELookBehOverrun   },
    { LZO_E_EOF_NOT_FOUND,       EEofNotFound      },
    { LZO_E_INPUT_NOT_CONSUMED,  EInputNotConsumed },
    { LZO_E_NOT_YET_IMPLEMENTED, ENotSupported     },
    { 0, 0 }
};

//------------------------------------------------------------------------------
/*static*/
int SDataCompressorUtils::getError (PackAlgo algo,int errno)
{
    const ErrMap *emap = SLzoErrors;

    if (!errno) {
        return ENoerror;
    }

    int rv = EError;
    for (ErrMap *m=(ErrMap*)emap;; m++)
    {
        if (!m->zip_err) {
            break;
        }

        if (m->zip_err == errno)
        {
            rv = m->dc_err;
            break;
        }
    }

    return rv;
}

// __END__
